#pragma once

#include <systypes/base.h>

#include <list>
#include <mutex>

#include "memory.h"



/* A memory pool abstraction. */

class MemoryPreallocated : public Memory
{
protected:
    std::mutex _lock;
    std::list<Region *> _regions;

    Memory *_memory;
    offset_t _amount;

public:
    explicit MemoryPreallocated(Memory *memory, offset_t amount);

    explicit MemoryPreallocated();

    virtual Region *region();

    virtual offset_t region_size()
    { return _memory->region_size(); }

    virtual void release(Region *region);
};

// vim: tabstop=4 expandtab shiftwidth=4
